# "separa" serve per separare in serie i grafoclitici di un testo.
# Richiede il file "conencl" contenente ($1) la lista delle catene clitiche
# seguite dai loro costituenti ($2-n) separati da spazio, tipo
# daccene  da  cce  ne
#
# Il nome del file di uscita va dato dall'esterno, preceduto da >
# (o >> se si esegue il programma pi volte su input diversi da riunire
# in un unico file di uscita).
#
#
BEGIN {
while((getline < "conencl") > 0)
        {
        indic =  $1
        $1 = ""
        sub (/^ /,"",$0)
        tabel[indic] = $0
        }
close("conencl")
}
{
nf = 0
while(nf < NF)
        {
        nf++
        if(($nf in tabel) == 0)
                continue
        $nf = tabel[$nf]
        sum++
        # ++ aggiunge il totale delle subst.
        sub (/^/," ",$0)
        # dato che tutte le righe iniziano con uno spazio
        # (una parola  tale solo se ha uno spazio a sinistra)
        # bisogna reintegrare uno spazio ad inizio riga
        }
print
}
# quanto segue serve solo se si attiva il sum ++
END {
    print sum
    }
